//+------------------------------------------------------------------+
//|                                                  Heiken Ashi.mq4 |
//|                      Copyright c 2004, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//| For Heiken Ashi we recommend next chart settings ( press F8 or   |
//| select on menu 'Charts'->'Properties...'):                       |
//|  - On 'Color' Tab select 'Black' for 'Line Graph'                |
//|  - On 'Common' Tab disable 'Chart on Foreground' checkbox and    |
//|    select 'Line Chart' radiobutton                               |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//
//
//
//
//

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  Red
#property indicator_color2  SkyBlue
#property indicator_color3  Red
#property indicator_color4  SkyBlue
#property indicator_color5  Yellow
#property indicator_color6  Yellow
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  1
#property indicator_width6  1

//
//
//
//
//

extern int    Upper_Ma_Period = 5;
extern int    Lower_Ma_Period = 5;

extern string _not            = "Ma Types";
extern string _note           = "0=sma,1=ema,2=ssma,3=lwms";
extern int    Upper_Ma_Method = 2;
extern int    Lower_Ma_Method = 2;

extern string _note1          = "0=close,1=open,2=high,3=low";
extern string _cont           = "4=H+L/2,5=H+L+C/3,6=H+L+C+C/4";
extern int    Upper_Ma_Price  = PRICE_HIGH;
extern int    Lower_Ma_Price  = PRICE_LOW;

extern bool  alertsOn         = true;
extern bool  alertsOnCurrent  = true;
extern bool  alertsMessage    = true;
extern bool  alertsSound      = false;
extern bool  alertsEmail      = false;





double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double uPac[];
double lPac[];
double trend[];





int init()
  {
   IndicatorBuffers(7);
   SetIndexBuffer(0, ExtMapBuffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, ExtMapBuffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, ExtMapBuffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3, ExtMapBuffer4); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4, uPac);          SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(5, lPac);          SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(6, trend);

   return(0);
  }



int start()
  {
   int    counted_bars=IndicatorCounted();
   int    pos,limit;

   //
   //
   //
   //
   //
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-1,Bars-counted_bars-1);      
          
   //
   //
   //
   //
   //
   
          for(pos=limit; pos >= 0; pos--)
          {
          double haClose = (Open[pos]+High[pos]+Low[pos]+Close[pos])/4;
          double haOpen  = (ExtMapBuffer3[pos+1]+ExtMapBuffer4[pos+1])/2;
          double haHigh  = MathMax(High[pos], MathMax(haOpen,haClose));
          double haLow   = MathMin(Low[pos],  MathMin(haOpen,haClose));

         if (haOpen<haClose) 
         { 
         ExtMapBuffer1[pos] = haLow;  
         ExtMapBuffer2[pos] = haHigh; 
         } 
         else              
         { 
         ExtMapBuffer1[pos] = haHigh; 
         ExtMapBuffer2[pos] = haLow;  
         } 
         ExtMapBuffer3[pos] = haOpen;
         ExtMapBuffer4[pos] = haClose; 
         uPac[pos]          = iMA(NULL,0,Upper_Ma_Period,0,Upper_Ma_Method,Upper_Ma_Price,pos);  
         lPac[pos]          = iMA(NULL,0,Lower_Ma_Period,0,Lower_Ma_Method,Lower_Ma_Price,pos);             
     
         trend[pos] = trend[pos+1];
         if (ExtMapBuffer3[pos] > ExtMapBuffer4[pos] && ExtMapBuffer4[pos] < lPac[pos]) trend[pos] = -1;
         if (ExtMapBuffer3[pos] < ExtMapBuffer4[pos] && ExtMapBuffer4[pos] > uPac[pos]) trend[pos] =  1;
         }
         
         //
         //
         //
         //
         //
   
        if (alertsOn)
        {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;

         //
         //
         //
         //
         //
         
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("up");
         else  doAlert("down");       
   }

   //
   //
   //
   //
          
   return(0);
}





void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," PA Bars & Channel trend changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," PA Bars & Channel "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+------------------------------------------------------------------+